import { User } from "../../realms/AdminRealm";
import { AuthProvider } from "../AuthProvider";
export interface AzureAuthProviderConfig {
    tenant_id: string;
    skipVerification?: boolean;
    audience?: string;
    allowConsumerLogins?: boolean;
    userIdField?: "sub" | "oid" | "preferred_username" | "unique_name";
    appId?: string;
}
export declare class AzureAuthProvider extends AuthProvider {
    name: string;
    private readonly responseCache;
    private readonly tenantId;
    private readonly skipVerification;
    private readonly audience?;
    private readonly validIssuers;
    private readonly validTenantIds;
    private readonly userIdField;
    private readonly appId?;
    constructor(config: AzureAuthProviderConfig);
    authenticateOrCreateUser(body: any): Promise<User>;
    private httpGet;
    private validateSignature;
    private getOpenIdUrl;
}
