import { RealmDefinition } from "../../RealmFactory";
import { Realm, BaseRealmClass } from "../../shared/realmUtil";
export declare class PasswordSaltHash extends BaseRealmClass {
    static schema: Realm.ObjectSchema;
    userId: string;
    salt: string;
    iterations: number;
    keyLength: number;
    digest: string;
    hash: string;
    isEmailConfirmed: boolean;
}
export declare class PasswordResetRequest extends BaseRealmClass {
    static schema: Realm.ObjectSchema;
    token: string;
    userId: string;
    expires: Date;
    consumed?: Date;
}
export declare class EmailConfirmationRequest extends BaseRealmClass {
    static schema: Realm.ObjectSchema;
    token: string;
    userId: string;
    email: string;
    expires: Date;
    consumed?: Date;
}
export declare const PasswordRealm: RealmDefinition;
