"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealmFactory_1 = require("../RealmFactory");
const realmUtil_1 = require("../shared/realmUtil");
class AuthProviderConfig extends realmUtil_1.BaseRealmClass {
}
AuthProviderConfig.schema = {
    name: "AuthProviderConfig",
    primaryKey: "name",
    properties: {
        name: { type: "string", optional: false },
        type: { type: "string", optional: false },
        config: { type: "string", optional: true },
        forceCodeConfig: "bool"
    }
};
exports.AuthProviderConfig = AuthProviderConfig;
class ServiceConfig extends realmUtil_1.BaseRealmClass {
}
ServiceConfig.schema = {
    name: "ServiceConfig",
    primaryKey: "serviceName",
    properties: {
        serviceName: "string",
        version: "int",
        config: "string?",
    },
};
exports.ServiceConfig = ServiceConfig;
exports.ConfigurationRealm = {
    remotePath: "/__configuration",
    syncLabel: "default",
    schema: [
        RealmFactory_1.createRealmSchema(AuthProviderConfig),
        RealmFactory_1.createRealmSchema(ServiceConfig),
    ],
};
//# sourceMappingURL=ConfigurationRealm.js.map