"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealmFactory_1 = require("../RealmFactory");
const realmUtil_1 = require("../shared/realmUtil");
class UserSpecificPermission extends realmUtil_1.BaseRealmClass {
}
UserSpecificPermission.schema = {
    name: "Permission",
    properties: {
        userId: { type: "string", indexed: true },
        path: { type: "string", indexed: true },
        mayRead: { type: "bool", optional: false },
        mayWrite: { type: "bool", optional: false },
        mayManage: { type: "bool", optional: false },
        updatedAt: { type: "date", optional: false },
    }
};
exports.UserSpecificPermission = UserSpecificPermission;
function CreateUserPermissionRealmDefinition(userId) {
    return {
        remotePath: `/${userId}/__permission`,
        schema: [
            RealmFactory_1.createRealmSchema(UserSpecificPermission)
        ],
    };
}
exports.CreateUserPermissionRealmDefinition = CreateUserPermissionRealmDefinition;
//# sourceMappingURL=UserPermissionRealm.js.map