"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const RealmFactory_1 = require("../RealmFactory");
const realmUtil_1 = require("../shared/realmUtil");
class WildcardSpecificPermission extends realmUtil_1.BaseRealmClass {
}
WildcardSpecificPermission.schema = {
    name: "Permission",
    properties: {
        userId: { type: "string", default: "*" },
        path: { type: "string", indexed: true },
        mayRead: { type: "bool", optional: false },
        mayWrite: { type: "bool", optional: false },
        mayManage: { type: "bool", optional: false },
        updatedAt: { type: "date", optional: false },
    }
};
exports.WildcardSpecificPermission = WildcardSpecificPermission;
exports.WildcardPermissionRealm = {
    remotePath: "/__wildcardpermissions",
    syncLabel: "default",
    schema: [
        RealmFactory_1.createRealmSchema(WildcardSpecificPermission)
    ],
};
//# sourceMappingURL=WildcardPermissionRealm.js.map