/// <reference types="node" />
import { RealmType } from "../realms/RealmType";
import { EventEmitter } from "events";
import { StrictEventEmitter } from "strict-event-emitter-types";
interface RealmDirectoryServiceEvents {
    realmCreated: {
        type: RealmType;
        path: string;
        syncLabel: string;
        overallStats: {
            [realmType in keyof typeof RealmType]: number;
        };
    };
}
declare const RealmDirectoryService_base: new () => StrictEventEmitter<EventEmitter, RealmDirectoryServiceEvents, RealmDirectoryServiceEvents, "addEventListener" | "removeEventListener", "removeListener" | "on" | "addListener" | "once" | "emit">;
export declare class RealmDirectoryService extends RealmDirectoryService_base {
    private logger;
    private adminToken;
    private protectedRealmPaths;
    private discovery;
    private adminRealm;
    private authorizationHeaderName;
    private serviceAgent?;
    private server;
    private setLogger;
    private getRealms;
    private findByPath;
    private remove;
    private changeType;
    private compact;
    private calculateSize;
    private start;
    private stop;
    private findSyncLabel;
    private findRealmFile;
    private findOrCreateRealmFile;
    private static getRealmFileDetails;
}
export {};
