import { RealmDefinition } from "../RealmFactory";
import { Logger } from "../shared";
import { StatsdReceiver } from "./StatsdReceiver";
export interface StatsdToMetricsRealmConfiguration {
    logger: Logger;
    openRealm: (definition: RealmDefinition) => Promise<Realm>;
    saveWait?: number;
}
export declare class StatsdToMetricsRealm {
    private static DEFAULT_SAVE_WAIT;
    private logger;
    private receiver;
    private openRealm;
    private realm;
    private mappings;
    private metricsToSave;
    private saveMetrics;
    constructor(config: StatsdToMetricsRealmConfiguration, receiver?: StatsdReceiver);
    listenTo(receiver: StatsdReceiver): void;
    stop(): void;
    private onMetric;
    private handleMetric;
    private doSaveMetrics;
    private ensureRealm;
}
